SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

IF NOT EXISTS (SELECT * FROM sys.tables WHERE name = 'Properties')
BEGIN
	CREATE TABLE [Properties](
		[ID] [uniqueidentifier] NOT NULL,
		[Key] [nvarchar](256) PRIMARY KEY,
		[Value] [ntext] NOT NULL
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * from sysobjects o inner join syscolumns c on o.id = c.cdefault inner join sysobjects t on c.id = t.id where o.xtype = 'd' and o.name = 'DF_Properties_ID' and t.name = 'Properties')
BEGIN
	ALTER TABLE [Properties] ADD  CONSTRAINT [DF_Properties_ID]  DEFAULT (newsequentialid()) FOR [ID]
END
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'VisitorClassifications' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [VisitorClassifications]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'ReferringSites' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [ReferringSites]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Browsers' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Browsers]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Keywords' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Keywords]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'OS' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [OS]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Screens' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Screens]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'UserAgents' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [UserAgents]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Locations' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Locations]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Visitors' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Visitors]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'NotificationSubscriptions' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [NotificationSubscriptions]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'Profiles' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [Profiles]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE TABLE_NAME = 'ItemUrls' AND COLUMN_NAME = 'RowVersion')
BEGIN
	ALTER TABLE [ItemUrls]
	ADD [RowVersion] [rowversion] NOT NULL
END

GO
