CREATE TABLE "IPOwner"(
	"IpOwnerId" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
	"Country" NCLOB NULL,
	"VisitorIdentification" NUMBER(10,0) NOT NULL,
	"ExternalUser" NVARCHAR2(50) NULL,
 CONSTRAINT "PK_IPOwner" PRIMARY KEY  
(
	"IpOwnerId"
)
) 
/
CREATE TABLE "Browser"(
	"BrowserId" CHAR(32) NOT NULL,
	"UserAgent" NCLOB NULL,
	"Description" NCLOB NULL,
	"Comment" NVARCHAR2(255) NULL,
	"Link1" NVARCHAR2(255) NULL,
	"Link2" NVARCHAR2(255) NULL,
	"VisitorIdentification" NUMBER(10,0) NOT NULL,
	"MajorName" NVARCHAR2(250) NULL,
	"Version" NVARCHAR2(250) NULL,
 CONSTRAINT "PK_Browser" PRIMARY KEY  
(
	"BrowserId"
)
) 
/
CREATE TABLE "GlobalSession"(
	"GlobalSessionId" CHAR(32) NOT NULL,
	"CookieValue" NCLOB NULL,
	"VisitorIdentification" NUMBER(10,0) NOT NULL,
	"OverridenVisitorIdent" NUMBER(10,0) NOT NULL,
	"ExternalUser" NVARCHAR2(50) NULL,
 CONSTRAINT "PK_GlobalCookie" PRIMARY KEY  
(
	"GlobalSessionId"
)
) 
/
CREATE  INDEX "IX_VisitorIdentification_Globa" ON "GlobalSession" 
(
	"VisitorIdentification"
)
/
CREATE TABLE "Screen"(
	"ScreenId" CHAR(32) NOT NULL,
	"Dimensions" NCLOB NULL,
	"Description" NCLOB NULL,
 CONSTRAINT "PK_Screen" PRIMARY KEY  
(
	"ScreenId"
)
) 
/
CREATE TABLE "MVTestDefinition"(
	"MVTestDefinitionId" CHAR(32) NOT NULL,
	"Title" NCLOB NULL,
	"Description" NCLOB NULL,
 CONSTRAINT "PK_TestDefinition" PRIMARY KEY  
(
	"MVTestDefinitionId"
)
) 
/
CREATE TABLE "OperatingSystem"(
	"OperatingSystemId" CHAR(32) NOT NULL,
	"OperatingSystem" NCLOB NULL,
	"Description" NCHAR(10) NOT NULL,
	"MajorName" NVARCHAR2(250) NULL,
	"MinorName" NVARCHAR2(250) NULL,
	"Version" NVARCHAR2(250) NULL,
 CONSTRAINT "PK_OS" PRIMARY KEY  
(
	"OperatingSystemId"
)
) 
/
CREATE TABLE "ReferringSite"(
	"ReferringSiteId" CHAR(32) NOT NULL,
	"URL" NCLOB NULL,
 CONSTRAINT "PK_ReferringSite" PRIMARY KEY  
(
	"ReferringSiteId"
)
) 
/
CREATE TABLE "VisitorIdentification"(
	"VisitorIdentification" NUMBER(10,0) NOT NULL,
	"Description" NVARCHAR2(50) NULL,
 CONSTRAINT "PK_VisitorIdentifications" PRIMARY KEY  
(
	"VisitorIdentification"
)
) 
/
CREATE TABLE "Status"(
	"Id" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
	"LastSuccessful" TIMESTAMP(3) NULL,
	"LastFailed" TIMESTAMP(3) NULL,
 CONSTRAINT "PK_Status" PRIMARY KEY  
(
	"Id"
)
) 
/
CREATE TABLE "ProfileDefinition"(
	"ProfileDefinitionId" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
	"ProfileType" NCLOB NULL,
 CONSTRAINT "PK_ProfileDefinition" PRIMARY KEY  
(
	"ProfileDefinitionId"
)
) 
/
CREATE TABLE "Keyword"(
	"KeywordId" CHAR(32) NOT NULL,
	"Keywords" NCLOB NULL,
 CONSTRAINT "PK_Keyword" PRIMARY KEY  
(
	"KeywordId"
)
) 
/
CREATE TABLE "PageEventDefinition"(
	"PageEventDefinitionId" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
	"Icon" NCLOB NULL,
	"Description" NCLOB NULL,
	"IsSystem" NUMBER(10,0) NOT NULL,
	"IsAuthorFeedback" NUMBER(10,0) NOT NULL,
	"IsGoal" NUMBER(10,0) NOT NULL,
	"IsFailure" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_CategoryDefinition" PRIMARY KEY  
(
	"PageEventDefinitionId"
)
) 
/
CREATE TABLE "Campaign"(
	"CampaignId" CHAR(32) NOT NULL,
	"Type" NCLOB NULL,
	"Title" NCLOB NULL,
	"Description" NCLOB NULL,
	"Cost" FLOAT NOT NULL,
	"StartDate" TIMESTAMP(3) NOT NULL,
	"EndDate" TIMESTAMP(3) NOT NULL,
	"Data" NCLOB NULL,
	"IsActive" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_Campaign" PRIMARY KEY  
(
	"CampaignId"
)
) 
/
CREATE TABLE "Subscription"(
	"SubscriptionId" CHAR(32) NOT NULL,
	"IpOwnerId" CHAR(32) NOT NULL,
	"Recipients" NVARCHAR2(500) NULL,
 CONSTRAINT "PK_Subscription" PRIMARY KEY  
(
	"SubscriptionId"
)
) 
/
CREATE  INDEX "IX_Subscription_IpOwnerId_Subs" ON "Subscription" 
(
	"IpOwnerId"
)
/
CREATE TABLE "IP"(
	"IpId" CHAR(32) NOT NULL,
	"IpOwnerId" CHAR(32) NOT NULL,
	"IpAddressFrom" NVARCHAR2(50) NULL,
	"IpAddressTo" NVARCHAR2(50) NULL,
	"City" NCLOB NULL,
	"PostalCode" NCLOB NULL,
	"Latitude" NCLOB NULL,
	"Longitude" NCLOB NULL,
	"MetroCode" NCLOB NULL,
	"AreaCode" NCLOB NULL,
	"Region" NCLOB NULL,
	"IspName" NCLOB NULL,
	"Dns" NCLOB NULL,
	"VisitorIdentification" NUMBER(10,0) NOT NULL,
	"DnsVisitorIdentification" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_IP" PRIMARY KEY  
(
	"IpId"
)
) 
/
CREATE  INDEX "IX_IP_IpOwnerId" ON "IP" 
(
	"IpOwnerId"
)
/
CREATE TABLE "Session"(
	"SessionId" CHAR(32) NOT NULL,
	"Timestamp" TIMESTAMP(3) NOT NULL,
	"AspNetSessionId" NVARCHAR2(50) NULL,
	"IpId" CHAR(32) NOT NULL,
	"IpAddress" NVARCHAR2(50) NULL,
	"GlobalSessionId" CHAR(32) NOT NULL,
	"GlobalVisitNo" NUMBER(10,0) NOT NULL,
	"Domain" NCLOB NULL,
	"MultiSite" NCLOB NULL,
	"ScreenId" CHAR(32) NOT NULL,
	"OperatingSystemId" CHAR(32) NOT NULL,
	"ReferringSiteId" CHAR(32) NOT NULL,
	"KeywordId" CHAR(32) NOT NULL,
	"BrowserId" CHAR(32) NOT NULL,
	"LanguageId" CHAR(32) NOT NULL,
	"CurrentPage" NUMBER(10,0) NOT NULL,
	"LastPageTimestamp" TIMESTAMP(3) NOT NULL,
 CONSTRAINT "PK_Session_1" PRIMARY KEY  
(
	"SessionId"
)
) 
/
CREATE  INDEX "IX_CurrentPage_Timestamp_Sessi" ON "Session" 
(
	"CurrentPage",
	"Timestamp"
)
/
CREATE  INDEX "IX_GlobalVisitNo_Timestamp_Ses" ON "Session" 
(
	"GlobalSessionId",
	"Timestamp"
)
/
CREATE  INDEX "IX_Session_AspNetSessionId_Ses" ON "Session" 
(
	"AspNetSessionId"
)
/
CREATE  INDEX "IX_Session_BrowserId" ON "Session" 
(
	"BrowserId"
)
/
CREATE  INDEX "IX_Session_GlobalSessionId_Ses" ON "Session" 
(
	"GlobalSessionId"
)
/
CREATE  INDEX "IX_Session_IpId" ON "Session" 
(
	"IpId"
)
/
CREATE  INDEX "IX_Session_Timestamp" ON "Session" 
(
	"Timestamp" DESC
)
/
CREATE TABLE "Tag"(
	"TagId" CHAR(32) NOT NULL,
	"GlobalSessionId" CHAR(32) NOT NULL,
	"Data" NCLOB NULL,
	"Acquaintance" CHAR(32) NOT NULL,
 CONSTRAINT "PK_Tag" PRIMARY KEY  
(
	"TagId"
)
) 
/
CREATE  INDEX "IX_Tag_GlobalSessionId" ON "Tag" 
(
	"GlobalSessionId"
)
/
CREATE TABLE "MVTestVariable"(
	"MVTestVariableId" CHAR(32) NOT NULL,
	"MVTestDefinitionId" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
 CONSTRAINT "PK_TestVariable" PRIMARY KEY  
(
	"MVTestVariableId"
)
) 
/
CREATE TABLE "MVTestVariablePage"(
	"MVTestVariablePageId" CHAR(32) NOT NULL,
	"MVTestVariableId" CHAR(32) NOT NULL,
	"PageId" CHAR(32) NOT NULL,
	"Data" NCLOB NULL,
 CONSTRAINT "PK_TestVariablePage" PRIMARY KEY  
(
	"MVTestVariablePageId"
)
) 
/
CREATE TABLE "MVTestVariableCampaignEvent"(
	"MVTestVariableCampaignEventId" CHAR(32) NOT NULL,
	"MVTestVariableId" CHAR(32) NOT NULL,
	"CampaignEventId" CHAR(32) NOT NULL,
	"Data" NCLOB NULL,
 CONSTRAINT "PK_TestVariableCampaignEvent" PRIMARY KEY  
(
	"MVTestVariableCampaignEventId"
)
) 
/
CREATE TABLE "Profile"(
	"ProfileId" CHAR(32) NOT NULL,
	"ProfileDefinitionId" CHAR(32) NOT NULL,
	"SessionId" CHAR(32) NOT NULL,
	"Total" NUMBER(10,0) NOT NULL,
	"Count" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_Profile" PRIMARY KEY  
(
	"ProfileId"
)
) 
/
CREATE  INDEX "IX_Profile_SessionId" ON "Profile" 
(
	"SessionId"
)
/
CREATE TABLE "Page"(
	"PageId" CHAR(32) NOT NULL,
	"SessionId" CHAR(32) NOT NULL,
	"Timestamp" TIMESTAMP(3) NOT NULL,
	"Duration" NUMBER(10,0) NOT NULL,
	"PageNo" NUMBER(10,0) NOT NULL,
	"ItemId" CHAR(32) NOT NULL,
	"ItemLanguage" NVARCHAR2(50) NULL,
	"ItemVersion" NUMBER(10,0) NOT NULL,
	"DeviceId" CHAR(32) NOT NULL,
	"Navigation" NCHAR(10) NOT NULL,
	"Url" NCLOB NULL,
	"IndexableUrl" NVARCHAR2(900) NULL,
	"Data" NCLOB NULL,
 CONSTRAINT "PK_SessionEvent" PRIMARY KEY  
(
	"PageId"
)
) 
/
CREATE  INDEX "IX_Page_IndexableUrl" ON "Page" 
(
	"IndexableUrl"
)
/
CREATE  INDEX "IX_Page_ItemId" ON "Page" 
(
	"ItemId"
)
/
CREATE  INDEX "IX_Page_SessionId" ON "Page" 
(
	"SessionId"
)
/
CREATE  INDEX "IX_PageNo_Timestamp_ItemId_Pag" ON "Page" 
(
	"PageNo",
	"Timestamp",
	"ItemId"
)
/
CREATE  INDEX "IX_Session_Timestamp_Page" ON "Page" 
(
	"PageNo",
	"ItemId"
)
/
CREATE TABLE "ProfileKey"(
	"ProfileKeyId" CHAR(32) NOT NULL,
	"ProfileId" CHAR(32) NOT NULL,
	"ProfileKeyDefinitionId" CHAR(32) NOT NULL,
	"Value" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_ProfileKey" PRIMARY KEY  
(
	"ProfileKeyId"
)
) 
/
CREATE  INDEX "IX_ProfileKey_ProfileId_Profil" ON "ProfileKey" 
(
	"ProfileId"
)
/
CREATE TABLE "ProfileKeyDefinition"(
	"ProfileKeyDefinitionId" CHAR(32) NOT NULL,
	"ProfileDefinitionId" CHAR(32) NOT NULL,
	"Name" NCLOB NULL,
	"MinValue" NUMBER(10,0) NOT NULL,
	"MaxValue" NUMBER(10,0) NOT NULL,
	"Control" NCLOB NULL,
 CONSTRAINT "PK_ProfileKeyDefinition" PRIMARY KEY  
(
	"ProfileKeyDefinitionId"
)
) 
/
CREATE TABLE "PageEvent"(
	"PageEventId" CHAR(32) NOT NULL,
	"PageId" CHAR(32) NOT NULL,
	"PageEventDefinitionId" CHAR(32) NOT NULL,
	"ItemId" CHAR(32) NOT NULL,
	"ItemLanguage" NCLOB NULL,
	"ItemVersion" NUMBER(10,0) NOT NULL,
	"Text" NCLOB NULL,
	"DataKey" NVARCHAR2(900) NULL,
	"Data" NCLOB NULL,
	"Integer" NUMBER(10,0) NOT NULL,
	"Timestamp" INTEGER NOT NULL,
	"CustomSorting" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_PageEvent" PRIMARY KEY  
(
	"PageEventId"
)
) 
/
CREATE  INDEX "IX_PageEvent_DataKey" ON "PageEvent" 
(
	"DataKey"
)
/
CREATE  INDEX "IX_PageEvent_PageEventDefiniti" ON "PageEvent" 
(
	"PageEventDefinitionId"
)
/
CREATE  INDEX "IX_PageEvent_PageId" ON "PageEvent" 
(
	"PageId"
)
/
CREATE TABLE "CampaignEventPage"(
	"CampaignSessionPageId" CHAR(32) NOT NULL,
	"PageId" CHAR(32) NOT NULL,
	"CampaignEventId" CHAR(32) NOT NULL,
 CONSTRAINT "PK_CampaignSession" PRIMARY KEY  
(
	"CampaignSessionPageId"
)
) 
/
CREATE TABLE "CampaignEvent"(
	"CampaignEventId" CHAR(32) NOT NULL,
	"CampaignId" CHAR(32) NOT NULL,
	"DateTime" TIMESTAMP(3) NOT NULL,
	"Data" NCLOB NULL,
	"State" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_CampaignEvent" PRIMARY KEY  
(
	"CampaignEventId"
)
) 
/
ALTER TABLE "Browser" MODIFY "Comment"
 DEFAULT ('')
/
ALTER TABLE "Browser" MODIFY "Link1"
 DEFAULT ('')
/
ALTER TABLE "Browser" MODIFY "Link2"
 DEFAULT ('')
/
ALTER TABLE "Browser" MODIFY "VisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "Browser" MODIFY "MajorName"
 DEFAULT ('')
/
ALTER TABLE "Browser" MODIFY "Version"
 DEFAULT ('')
/
ALTER TABLE "Campaign" MODIFY "Data"
 DEFAULT ('')
/
ALTER TABLE "Campaign" MODIFY "IsActive"
 DEFAULT ((1))
/
ALTER TABLE "CampaignEvent" MODIFY "State"
 DEFAULT ((0))
/
ALTER TABLE "GlobalSession" MODIFY "VisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "GlobalSession" MODIFY "OverridenVisitorIdent"
 DEFAULT ((0))
/
ALTER TABLE "GlobalSession" MODIFY "ExternalUser"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "IpId"
 DEFAULT (SYS_GUID())
/
ALTER TABLE "IP" MODIFY "IpOwnerId"
 DEFAULT ('1AFB289FDABDE64C9521D7E6C6D8BB9D')
/
ALTER TABLE "IP" MODIFY "IpAddressFrom"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "IpAddressTo"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "City"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "PostalCode"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "Latitude"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "Longitude"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "MetroCode"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "AreaCode"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "Region"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "IspName"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "Dns"
 DEFAULT ('')
/
ALTER TABLE "IP" MODIFY "VisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "IP" MODIFY "DnsVisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "IPOwner" MODIFY "VisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "IPOwner" MODIFY "ExternalUser"
 DEFAULT ('')
/
ALTER TABLE "OperatingSystem" MODIFY "MajorName"
 DEFAULT ('')
/
ALTER TABLE "OperatingSystem" MODIFY "MinorName"
 DEFAULT ('')
/
ALTER TABLE "OperatingSystem" MODIFY "Version"
 DEFAULT ('')
/
ALTER TABLE "Page" MODIFY "IndexableUrl"
 DEFAULT ('')
/
ALTER TABLE "PageEvent" MODIFY "Text"
 DEFAULT ('')
/
ALTER TABLE "PageEvent" MODIFY "DataKey"
 DEFAULT ('')
/
ALTER TABLE "PageEvent" MODIFY "Integer"
 DEFAULT ((0))
/
ALTER TABLE "PageEvent" MODIFY "CustomSorting"
 DEFAULT ((0))
/
ALTER TABLE "PageEventDefinition" MODIFY "PageEventDefinitionId"
 DEFAULT (SYS_GUID())
/
ALTER TABLE "PageEventDefinition" MODIFY "IsAuthorFeedback"
 DEFAULT ((0))
/
ALTER TABLE "PageEventDefinition" MODIFY "IsGoal"
 DEFAULT ((0))
/
ALTER TABLE "PageEventDefinition" MODIFY "IsFailure"
 DEFAULT ((0))
/
ALTER TABLE "ProfileDefinition" MODIFY "ProfileDefinitionId"
 DEFAULT (SYS_GUID())
/
ALTER TABLE "ProfileKeyDefinition" MODIFY "ProfileKeyDefinitionId"
 DEFAULT (SYS_GUID())
/
ALTER TABLE "ProfileKeyDefinition" MODIFY "Control"
 DEFAULT ('')
/
ALTER TABLE "Session" MODIFY "IpAddress"
 DEFAULT ('')
/
ALTER TABLE "Session" MODIFY "CurrentPage"
 DEFAULT ((0))
/
ALTER TABLE "Subscription" MODIFY "SubscriptionId"
 DEFAULT (SYS_GUID())
/
ALTER TABLE "Subscription" MODIFY "Recipients"
 DEFAULT ('')
/
ALTER TABLE "VisitorIdentification" MODIFY "VisitorIdentification"
 DEFAULT ((0))
/
ALTER TABLE "VisitorIdentification" MODIFY "Description"
 DEFAULT ('')
/
ALTER TABLE "CampaignEvent"  
ADD CONSTRAINT "CampaignId1" FOREIGN KEY ("CampaignId") REFERENCES "Campaign" ("CampaignId")
/
ALTER TABLE "CampaignEventPage"  
ADD CONSTRAINT "CampaignEventId10" FOREIGN KEY ("CampaignEventId") REFERENCES "CampaignEvent" ("CampaignEventId")
/
ALTER TABLE "CampaignEventPage"  
ADD CONSTRAINT "PageId2" FOREIGN KEY ("PageId") REFERENCES "Page" ("PageId")
/
ALTER TABLE "IP"  
ADD CONSTRAINT "IpOwnerId20" FOREIGN KEY ("IpOwnerId") REFERENCES "IPOwner" ("IpOwnerId")
/
ALTER TABLE "MVTestVariable"  
ADD CONSTRAINT "MVTestDefinitionId21" FOREIGN KEY ("MVTestDefinitionId") REFERENCES "MVTestDefinition" ("MVTestDefinitionId")
/
ALTER TABLE "MVTestVariableCampaignEvent"  
ADD CONSTRAINT "CampaignEventId210" FOREIGN KEY ("CampaignEventId") REFERENCES "CampaignEvent" ("CampaignEventId")
/
ALTER TABLE "MVTestVariableCampaignEvent"  
ADD CONSTRAINT "MVTestVariableId3" FOREIGN KEY ("MVTestVariableId") REFERENCES "MVTestVariable" ("MVTestVariableId")
/
ALTER TABLE "MVTestVariablePage"  
ADD CONSTRAINT "PageId30" FOREIGN KEY ("PageId") REFERENCES "Page" ("PageId")
/
ALTER TABLE "MVTestVariablePage"  
ADD CONSTRAINT "MVTestVariableId31" FOREIGN KEY ("MVTestVariableId") REFERENCES "MVTestVariable" ("MVTestVariableId")
/
ALTER TABLE "Page"  
ADD CONSTRAINT "SessionId310" FOREIGN KEY ("SessionId") REFERENCES "Session" ("SessionId")
/
ALTER TABLE "PageEvent"  
ADD CONSTRAINT "PageEventDefinitionId32" FOREIGN KEY ("PageEventDefinitionId") REFERENCES "PageEventDefinition" ("PageEventDefinitionId")
/
ALTER TABLE "PageEvent"  
ADD CONSTRAINT "PageId320" FOREIGN KEY ("PageId") REFERENCES "Page" ("PageId")
/
ALTER TABLE "Profile"  
ADD CONSTRAINT "ProfileDefinitionId321" FOREIGN KEY ("ProfileDefinitionId") REFERENCES "ProfileDefinition" ("ProfileDefinitionId")
/
ALTER TABLE "Profile"  
ADD CONSTRAINT "SessionId3210" FOREIGN KEY ("SessionId") REFERENCES "Session" ("SessionId")
/
ALTER TABLE "ProfileKey"  
ADD CONSTRAINT "ProfileId33" FOREIGN KEY ("ProfileId") REFERENCES "Profile" ("ProfileId")
/
ALTER TABLE "ProfileKey"  
ADD CONSTRAINT "ProfileKeyDefinitionId330" FOREIGN KEY ("ProfileKeyDefinitionId") REFERENCES "ProfileKeyDefinition" ("ProfileKeyDefinitionId")
/
ALTER TABLE "ProfileKeyDefinition"  
ADD CONSTRAINT "ProfileDefinitionId331" FOREIGN KEY ("ProfileDefinitionId") REFERENCES "ProfileDefinition" ("ProfileDefinitionId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "BrowserId3310" FOREIGN KEY ("BrowserId") REFERENCES "Browser" ("BrowserId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "GlobalSessionId332" FOREIGN KEY ("GlobalSessionId") REFERENCES "GlobalSession" ("GlobalSessionId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "IpId3320" FOREIGN KEY ("IpId") REFERENCES "IP" ("IpId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "KeywordId3321" FOREIGN KEY ("KeywordId") REFERENCES "Keyword" ("KeywordId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "OperatingSystemId33210" FOREIGN KEY ("OperatingSystemId") REFERENCES "OperatingSystem" ("OperatingSystemId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "ReferringSiteId333" FOREIGN KEY ("ReferringSiteId") REFERENCES "ReferringSite" ("ReferringSiteId")
/
ALTER TABLE "Session"  
ADD CONSTRAINT "ScreenId3330" FOREIGN KEY ("ScreenId") REFERENCES "Screen" ("ScreenId")
/
ALTER TABLE "Subscription"  
ADD CONSTRAINT "IpOwnerId3331" FOREIGN KEY ("IpOwnerId") REFERENCES "IPOwner" ("IpOwnerId")
/
ALTER TABLE "Tag"  
ADD CONSTRAINT "GlobalSessionId33310" FOREIGN KEY ("GlobalSessionId") REFERENCES "GlobalSession" ("GlobalSessionId")
/
CREATE OR REPLACE FUNCTION ProfileKeyValue
(
  ProfileKeyDefinitionId IN "ProfileKeyDefinition"."ProfileKeyDefinitionId"%TYPE, 
  SessionId IN "Session"."SessionId"%TYPE
) 
RETURN FLOAT IS
  Value "ProfileKey"."Value"%TYPE;
  ProfileCount "Profile"."Count"%TYPE;
  Total "Profile"."Total"%TYPE;
  ProfileType "ProfileDefinition"."ProfileType"%TYPE;
BEGIN
  BEGIN
    SELECT
      "ProfileKey"."Value", 
      "Profile"."Count", 
      "Profile"."Total", 
      "ProfileDefinition"."ProfileType"
    INTO Value, ProfileCount, Total, ProfileType
    FROM 
      "ProfileKey", 
      "Profile", 
      "ProfileDefinition"
    WHERE
      rownum <= 1 and
      ProfileKeyDefinitionId = "ProfileKeyDefinitionId" and
      "ProfileKey"."ProfileId" = "Profile"."ProfileId" and
      "Profile"."ProfileDefinitionId" = "ProfileDefinition"."ProfileDefinitionId" and
      "Profile"."SessionId" = "SessionId";

    IF LOWER(TO_CHAR(ProfileType)) = 'sum' THEN
      return Value;
    ELSIF LOWER(TO_CHAR(ProfileType)) = 'percentage' THEN
      return Value / ProfileCount * 100;
    ELSIF LOWER(TO_CHAR(ProfileType)) = 'average' THEN
      return Value / Total;
    ELSE
      return 0;
    END IF;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      Value := 0;
      ProfileCount:= 0;
      Total := 0;
      ProfileType := 'nothing';

      return 0;
  WHEN OTHERS THEN
    RAISE;
  END;
END ProfileKeyValue;
/
CREATE OR REPLACE FUNCTION GetVisitorIdentification
(
  overridden IN INTEGER,
  p0 IN INTEGER,
  p1 IN INTEGER,
  p2 IN INTEGER,
  p3 IN INTEGER,
  p4 IN INTEGER
) 
RETURN INTEGER
IS
  IsAutoDetected INTEGER;
  ReturnValue INTEGER;
  overriddenVariable INTEGER;
BEGIN
  IsAutoDetected := 0;
  ReturnValue := 0;
  overriddenVariable := overridden;

  IF overridden = 925 THEN
    IsAutoDetected := 1;
    overriddenVariable := 0;
  END IF;

  IF overriddenVariable = 0 THEN
    IF p0 > p1 AND p0 > p2 AND p0 > p3 AND p0 > p4 THEN
      ReturnValue := p0;
    ELSIF p1 > p2 and p1 > p3 and p1 > p4 THEN
      ReturnValue := p1;
    ELSIF p2 > p3 AND p2 > p4 THEN
      ReturnValue := p2;
    ELSIF p3 > p4 THEN
      ReturnValue := p3;
    ELSE
      ReturnValue := p4;
    END IF;
  ELSE
    ReturnValue := overriddenVariable;
  END IF;

  IF IsAutoDetected = 1 AND ReturnValue < 900 THEN
    ReturnValue := 925;
  END IF;

  return ReturnValue;
END GetVisitorIdentification;
/
exit