CREATE TABLE "TRAFFICTYPES"(
	"TRAFFICTYPE" NUMBER(10,0) NOT NULL,
	"TEXT" NVARCHAR2(100) NULL,
 CONSTRAINT "PK_TRAFFICTYPES" PRIMARY KEY  
(
	"TRAFFICTYPE"
)
) 
/
CREATE TABLE "PAGEEVENTDEFINITIONS"(
	"PAGEEVENTDEFINITIONID" CHAR(36) NOT NULL,
	"NAME" NVARCHAR2(100) NULL,
	"VALUE" NUMBER(10,0) NOT NULL,
	"ISSYSTEM" NUMBER(1,0) NOT NULL,
	"ISAUTHORFEEDBACK" NUMBER(1,0) NOT NULL,
	"ISGOAL" NUMBER(1,0) NOT NULL,
	"ISFAILURE" NUMBER(1,0) NOT NULL,
 CONSTRAINT "PK_PAGEEVENTDEFINITIONS" PRIMARY KEY  
(
	"PAGEEVENTDEFINITIONID"
)
) 
/
CREATE  INDEX "IX_GOALSPAGEEVENTDEFINITIONS" ON "PAGEEVENTDEFINITIONS" 
(
	"ISGOAL"
)
/
CREATE TABLE "OS"(
	"OSID" CHAR(36) NOT NULL,
	"MAJORNAME" NVARCHAR2(250) NULL,
	"MINORNAME" NVARCHAR2(250) NULL,
	"VERSION" NVARCHAR2(250) NULL,
 CONSTRAINT "PK_OS" PRIMARY KEY  
(
	"OSID"
)
) 
/
CREATE TABLE "VISITORCLASSIFICATIONS"(
	"VISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
	"TEXT" NVARCHAR2(100) NULL,
 CONSTRAINT "PK_VISITORCLASSIFICATION" PRIMARY KEY  
(
	"VISITORCLASSIFICATION"
)
) 
/
CREATE TABLE "CAMPAIGNS"(
	"CAMPAIGNID" CHAR(36) NOT NULL,
	"CAMPAIGNNAME" NVARCHAR2(100) NULL,
	"COST" NUMBER(10,0) NOT NULL,
	"COSTPERCLICK" NUMBER(10,0) NOT NULL,
	"COSTPERDAY" NUMBER(10,0) NOT NULL,
	"COSTBASE" NUMBER(10,0) NOT NULL,
	"CATEGORY1LABEL" NVARCHAR2(100) NULL,
	"CATEGORY1ID" CHAR(36) NULL,
	"CATEGORY2LABEL" NVARCHAR2(100) NULL,
	"CATEGORY2ID" CHAR(36) NULL,
	"CATEGORY3LABEL" NVARCHAR2(100) NULL,
	"CATEGORY3ID" CHAR(36) NULL,
	"INTEGRATIONLABEL" NVARCHAR2(100) NULL,
	"INTEGRATIONID" CHAR(36) NULL,
	"ISACTIVE" NUMBER(1,0) NOT NULL,
	"STARTDATE" TIMESTAMP(3) NOT NULL,
	"ENDDATE" TIMESTAMP(3) NOT NULL,
	"DATA" NCLOB NULL,
 CONSTRAINT "PK_CAMPAIGN" PRIMARY KEY  
(
	"CAMPAIGNID"
)
) 
/
CREATE  INDEX "IX_CATEGORY1CAMPAIGNS" ON "CAMPAIGNS" 
(
	"CATEGORY1ID",
	"CAMPAIGNID"
)
/
CREATE  INDEX "IX_CATEGORY2CAMPAIGNS" ON "CAMPAIGNS" 
(
	"CATEGORY1ID",
	"CATEGORY2ID",
	"CAMPAIGNID"
)
/
CREATE  INDEX "IX_CATEGORY3CAMPAIGNS" ON "CAMPAIGNS" 
(
	"CATEGORY1ID",
	"CATEGORY2ID",
	"CATEGORY3ID",
	"CAMPAIGNID"
)
 
/
CREATE TABLE "BROWSERS"(
	"BROWSERID" CHAR(36) NOT NULL,
	"MAJORNAME" NVARCHAR2(50) NULL,
	"MINORNAME" NVARCHAR2(50) NULL,
	"VERSION" NVARCHAR2(16) NULL,
 CONSTRAINT "PK_BROWSERS" PRIMARY KEY  
(
	"BROWSERID"
)
) 
/
CREATE TABLE "KEYWORDS"(
	"KEYWORDSID" CHAR(36) NOT NULL,
	"TEXT" NCLOB NULL,
 CONSTRAINT "PK_KEYWORDS" PRIMARY KEY  
(
	"KEYWORDSID"
)
) 
/
CREATE TABLE "ITEMURLS"(
	"ITEMID" CHAR(36) NOT NULL,
	"URL" NVARCHAR2(800) NULL,
 CONSTRAINT "PK_ITEMURLS" PRIMARY KEY  
(
	"ITEMID"
)
) 
/
CREATE TABLE "TESTDEFINITIONS"(
	"TESTSETID" CHAR(36) NOT NULL,
	"TESTSETNAME" NVARCHAR2(100) NULL,
	"VARIABLEID" CHAR(36) NOT NULL,
	"VARIABLELABEL" NVARCHAR2(100) NULL,
	"VARIABLEINDEX" NUMBER(5,0) NOT NULL,
	"VALUEID" CHAR(36) NOT NULL,
	"VALUELABEL" NVARCHAR2(100) NULL,
	"VALUE" NUMBER(5,0) NOT NULL,
 CONSTRAINT "PK_TESTDEFINITIONS" PRIMARY KEY  
(
	"VALUEID"
)
) 
/
CREATE TABLE "STATUS"(
	"STATUSID" CHAR(36) NOT NULL,
	"INSTANCENAME" NVARCHAR2(50) NULL,
	"TEXT" NVARCHAR2(100) NULL,
	"LASTSUCCESSFUL" TIMESTAMP(3) NULL,
	"LASTFAILED" TIMESTAMP(3) NULL,
 CONSTRAINT "PK_STATUS" PRIMARY KEY  
(
	"STATUSID"
)
) 
/
-- =============================================
-- Author:		Dmitry Kostenko
-- Create date: 10-04-2011
-- Description:	Enables and rebuilds all the disabled indexes
-- =============================================
-- =============================================
-- Author:		Dmitry Kostenko
-- Create date: 08-12-2011
-- Description:	Enables foreign key constraints in the database
-- =============================================
-- =============================================
-- Author:		Dmitry Kostenko
-- Create date: 10-04-2011
-- Description:	Disables all non-clustered indexes in the database before loading data
-- =============================================
-- =============================================
-- Author:		Dmitry Kostenko
-- Create date: 08-12-2011
-- Description:	Disables foreign key constraints in the database
-- =============================================
CREATE TABLE "SCREENS"(
	"SCREENID" CHAR(36) NOT NULL,
	"TEXT" NCLOB NULL,
	"WIDTH" NUMBER(10,0) NOT NULL,
	"HEIGHT" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_SCREENS" PRIMARY KEY  
(
	"SCREENID"
)
) 
/
CREATE TABLE "REFERRINGSITES"(
	"REFERRINGSITEID" CHAR(36) NOT NULL,
	"HOST" NVARCHAR2(100) NULL,
	"TRAFFICTYPE" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_REFERRINGSITES" PRIMARY KEY  
(
	"REFERRINGSITEID"
)
) 
/
CREATE TABLE "GEOIPS"(
	"IP" RAW(16) NOT NULL,
	"VISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
	"CACHEDVALUE" NCLOB NULL,
	"FETCHED" TIMESTAMP(3) NULL,
	"STATUS" NUMBER(3,0) NOT NULL,
 CONSTRAINT "PK_GEOIPS" PRIMARY KEY  
(
	"IP"
)
) 
/
CREATE TABLE "LOCATIONS"(
	"LOCATIONID" CHAR(36) NOT NULL,
	"BUSINESSNAME" NVARCHAR2(100) NULL,
	"COUNTRY" NVARCHAR2(100) NULL,
	"VISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
	"INTEGRATIONID" CHAR(36) NULL,
	"INTEGRATIONLABEL" NVARCHAR2(50) NULL,
	"EXTERNALUSER" NVARCHAR2(100) NULL,
 CONSTRAINT "PK_LOCATION" PRIMARY KEY  
(
	"LOCATIONID"
)
) 
/
CREATE TABLE "AUTOMATIONS"(
	"AUTOMATIONID" CHAR(36) NOT NULL,
	"AUTOMATIONNAME" NVARCHAR2(100) NULL,
	"CAMPAIGNID" CHAR(36) NULL,
	"INTEGRATIONID" CHAR(36) NULL,
	"INTEGRATIONLABEL" NVARCHAR2(100) NULL,
	"SUSPENDED" NUMBER(1,0) NOT NULL,
	"DATA" NCLOB NULL,
 CONSTRAINT "PK_AUTOMATION" PRIMARY KEY  
(
	"AUTOMATIONID"
)
) 
/
CREATE TABLE "VISITORS"(
	"VISITORID" CHAR(36) NOT NULL,
	"VISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
	"OVERRIDEVISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
	"VISITCOUNT" NUMBER(10,0) NOT NULL,
	"VALUE" NUMBER(10,0) NOT NULL,
	"AUTHENTICATIONLEVEL" NUMBER(10,0) NOT NULL,
	"EXTERNALUSER" NVARCHAR2(100) NULL,
	"INTEGRATIONID" CHAR(36) NULL,
	"INTEGRATIONLABEL" NVARCHAR2(100) NULL,
 CONSTRAINT "PK_VISITORS" PRIMARY KEY  
(
	"VISITORID"
)
) 
/
CREATE TABLE "USERAGENTS"(
	"USERAGENTID" CHAR(36) NOT NULL,
	"USERAGENT" NCLOB NULL,
	"CACHEDVALUE" NCLOB NULL,
	"FETCHED" TIMESTAMP(3) NULL,
	"VISITORCLASSIFICATION" NUMBER(10,0) NOT NULL,
 CONSTRAINT "PK_USERAGENTS" PRIMARY KEY  
(
	"USERAGENTID"
)
) 
/
CREATE TABLE "NOTIFICATIONSUBSCRIPTIONS"(
	"NOTIFICATIONSUBSCRIPTIONSID" CHAR(36) NOT NULL,
	"LOCATIONID" CHAR(36) NOT NULL,
	"MAILRECIPIENTS" NVARCHAR2(254) NULL,
 CONSTRAINT "PK_NOTIFICATIONSUBSCRIPTIONS" PRIMARY KEY  
(
	"NOTIFICATIONSUBSCRIPTIONSID"
)
) 
/
CREATE TABLE "AUTOMATIONSTATES"(
	"AUTOMATIONSTATEID" CHAR(36) NOT NULL,
	"AUTOMATIONID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NULL,
	"USERNAME" NVARCHAR2(100) NULL,
	"CREATEDDATETIME" TIMESTAMP(3) NOT NULL,
	"ENTRYDATETIME" TIMESTAMP(3) NOT NULL,
	"WAKEUPDATETIME" TIMESTAMP(3) NULL,
	"STATEID" CHAR(36) NULL,
	"STATENAME" NVARCHAR2(100) NULL,
	"TESTSETID" CHAR(36) NULL,
	"TESTVALUES" RAW(16) NULL,
	"DATA" NCLOB NULL,
	"STATE" NUMBER(10,0) NOT NULL,
	"DATACODE" NUMBER(10,0) NOT NULL,
	"LASTACCESSEDDATETIME" TIMESTAMP(3) NULL,
 CONSTRAINT "PK_AUTOMATIONSTATE" PRIMARY KEY  
(
	"AUTOMATIONSTATEID"
)
) 
/
CREATE  INDEX "IX_STATE_AS" ON "AUTOMATIONSTATES" 
(
	"STATE",
	"WAKEUPDATETIME"
)
/
CREATE  INDEX "IX_BYAUTOMATION_AS" ON "AUTOMATIONSTATES" 
(
	"AUTOMATIONID",
	"STATEID"
)
/
CREATE  INDEX "IX_BYAUTOMATIONSTATE_AS" ON "AUTOMATIONSTATES" 
(
	"STATEID"
)
/
CREATE  INDEX "IX_BYTESTSET_AS" ON "AUTOMATIONSTATES" 
(
	"TESTSETID",
	"TESTVALUES"
)
/
CREATE  INDEX "IX_BYUSER_AS" ON "AUTOMATIONSTATES" 
(
	"USERNAME"
)
/
CREATE  INDEX "IX_BYVISITOR_AS" ON "AUTOMATIONSTATES" 
(
	"VISITORID"
)
/
CREATE TABLE "VISITS"(
	"VISITID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NOT NULL,
	"VISITORVISITINDEX" NUMBER(10,0) NOT NULL,
	"VISITPAGECOUNT" NUMBER(10,0) NOT NULL,
	"STARTDATETIME" TIMESTAMP(3) NOT NULL,
	"ENDDATETIME" TIMESTAMP(3) NOT NULL,
	"TRAFFICTYPE" NUMBER(10,0) NOT NULL,
	"VALUE" NUMBER(10,0) NOT NULL,
	"ASPNETSESSIONID" NVARCHAR2(50) NULL,
	"REFERRINGSITEID" CHAR(36) NOT NULL,
	"KEYWORDSID" CHAR(36) NOT NULL,
	"BROWSERID" CHAR(36) NOT NULL,
	"USERAGENTID" CHAR(36) NOT NULL,
	"OSID" CHAR(36) NOT NULL,
	"SCREENID" CHAR(36) NOT NULL,
	"CAMPAIGNID" CHAR(36) NULL,
	"RDNS" NVARCHAR2(450) NULL,
	"MULTISITE" NVARCHAR2(450) NULL,
	"LOCATIONID" CHAR(36) NOT NULL,
	"IP" RAW(16) NOT NULL,
	"BUSINESSNAME" NVARCHAR2(100) NULL,
	"CITY" NVARCHAR2(100) NULL,
	"POSTALCODE" NVARCHAR2(100) NULL,
	"METROCODE" NVARCHAR2(100) NULL,
	"AREACODE" NVARCHAR2(100) NULL,
	"REGION" NVARCHAR2(100) NULL,
	"ISPNAME" NVARCHAR2(100) NULL,
	"COUNTRY" NVARCHAR2(100) NULL,
	"LATITUDE" FLOAT NOT NULL,
	"LONGITUDE" FLOAT NOT NULL,
	"TESTSETID" CHAR(36) NULL,
	"TESTVALUES" RAW(16) NULL,
	"REFERRER" NCLOB NULL,
 CONSTRAINT "PK_VISITS" PRIMARY KEY  
(
	"VISITID"
)
) 
/
CREATE  INDEX "IX_BYDATEVISITS" ON "VISITS" 
(
	"STARTDATETIME",
	"VISITORID",
	"VISITID"
)
/
CREATE  INDEX "IX_BYLOCATIONVISITS" ON "VISITS" 
(
	"LOCATIONID",
	"STARTDATETIME"
)
/
CREATE  INDEX "IX_BYREFERRINGSITEVISITS" ON "VISITS" 
(
	"REFERRINGSITEID"
)
 
/
CREATE  INDEX "IX_BYTESTSETVISITS" ON "VISITS" 
(
	"TESTSETID",
	"TESTVALUES"
)
/
CREATE  INDEX "IX_BYVISITORVISITS" ON "VISITS" 
(
	"VISITORID",
	"VISITID"
)
/
CREATE  INDEX "IX_FIRSTVISITSVISITS" ON "VISITS" 
(
	"VISITORVISITINDEX",
	"VISITORID",
	"TRAFFICTYPE"
)
/
CREATE TABLE "VISITORTAGS"(
	"VISITORTAGID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NOT NULL,
	"TAGNAME" NVARCHAR2(450) NULL,
	"TAGVALUE" NCLOB NULL,
	"DATETIME" TIMESTAMP(3) NOT NULL,
	"ACQUAINTANCEID" CHAR(36) NOT NULL,
 CONSTRAINT "PK_VISITORTAGS" PRIMARY KEY  
(
	"VISITORTAGID"
)
) 
/
CREATE  INDEX "IX_BYVISITORVISITORTAGS" ON "VISITORTAGS" 
(
	"VISITORID"
)
/
CREATE MATERIALIZED VIEW "VALUEBYSOURCE"
AS
SELECT TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD') "DATE", "VISITS"."TRAFFICTYPE", 
  SUM("VISITORS"."VISITCOUNT") "VISITS", SUM("VISITORS"."VALUE") "VALUE", SUM("VISITS"."VALUE") "FIRSTVISITVALUE", 
  COUNT(*) "VISITORS"
FROM "VISITS", "VISITORS"
WHERE "VISITS"."VISITORVISITINDEX" = 1 AND "VISITS"."VISITORID" = "VISITORS"."VISITORID"
GROUP BY TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD'), "TRAFFICTYPE"
/
CREATE UNIQUE  INDEX "PKEYVALUEBYSOURCE" ON "VALUEBYSOURCE" 
(
	"DATE",
	"TRAFFICTYPE"
)
/
CREATE MATERIALIZED VIEW "VISITORSBYLOCATION"
AS
SELECT
    TO_CHAR( "STARTDATETIME", 'YYYYMMDD') "DATE",
    "VISITORS"."VISITORCLASSIFICATION",
	  "LOCATIONID",
	  "COUNTRY",
	  "REGION",
	  "VISITS"."VISITORID",
	  COUNT(*) "VISITS",
	  SUM("VISITS"."VALUE") "VALUE"
FROM
	  "VISITS", "VISITORS"
WHERE	
	  "VISITS"."VISITORID" = "VISITORS"."VISITORID" AND
	  "VISITORS"."VISITORCLASSIFICATION" < 900
GROUP BY
	  "VISITS"."VISITORID",
		"LOCATIONID",
		"COUNTRY",
		"REGION",
		"VISITORCLASSIFICATION",
		TO_CHAR( "STARTDATETIME", 'YYYYMMDD')
/
CREATE UNIQUE  INDEX "PKEYVISITORSBYLOCATION" ON "VISITORSBYLOCATION" 
(
	"DATE",
	"VISITORCLASSIFICATION",
	"COUNTRY",
	"REGION",
	"LOCATIONID",
	"VISITORID"
)
/
CREATE TABLE "PROFILES"(
	"PROFILEID" CHAR(36) NOT NULL,
	"VISITID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NOT NULL,
	"PROFILENAME" NVARCHAR2(50) NULL,
	"PATTERNVALUES" NCLOB NULL,
	"PATTERNLABEL" NCLOB NULL,
	"PATTERNID" CHAR(36) NULL,
 CONSTRAINT "PK_PROFILE" PRIMARY KEY  
(
	"PROFILEID"
)
) 
/
CREATE  INDEX "IX_BYVISITIDPROFILES" ON "PROFILES" 
(
	"VISITID"
)
/
CREATE  INDEX "IX_BYVISITORPROFILES" ON "PROFILES" 
(
	"VISITORID"
)
/
CREATE TABLE "PAGES"(
	"PAGEID" CHAR(36) NOT NULL,
	"VISITID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NOT NULL,
	"VISITPAGEINDEX" NUMBER(10,0) NOT NULL,
	"DATETIME" TIMESTAMP(3) NOT NULL,
	"ITEMID" CHAR(36) NOT NULL,
	"ITEMLANGUAGE" NVARCHAR2(50) NULL,
	"ITEMVERSION" NUMBER(10,0) NOT NULL,
	"DEVICEID" CHAR(36) NOT NULL,
	"URL" NVARCHAR2(800) NULL,
	"URLTEXT" NCLOB NULL,
	"TESTSETID" CHAR(36) NULL,
	"TESTVALUES" RAW(16) NULL,
	"DURATION" NUMBER(10,0) NULL,
	"DATA" NCLOB NULL,
 CONSTRAINT "PK_PAGES" PRIMARY KEY  
(
	"PAGEID"
)
) 
/
CREATE  INDEX "IX_BYDATEPAGES" ON "PAGES" 
(
	"DATETIME"
)
/
CREATE  INDEX "IX_BYTESTSETPAGES" ON "PAGES" 
(
	"TESTSETID",
	"TESTVALUES"
)
/
CREATE  INDEX "IX_BYURLPAGES" ON "PAGES" 
(
	"URL",
	"VISITID",
	"VISITPAGEINDEX"
)
/
CREATE  INDEX "IX_BYVISITORPAGES" ON "PAGES" 
(
	"VISITORID",
	"VISITID"
)
/
CREATE TABLE "PAGEEVENTS"(
	"PAGEEVENTID" CHAR(36) NOT NULL,
	"VISITORID" CHAR(36) NOT NULL,
	"PAGEEVENTDEFINITIONID" CHAR(36) NOT NULL,
	"PAGEID" CHAR(36) NOT NULL,
	"VISITID" CHAR(36) NOT NULL,
	"ITEMID" CHAR(36) NOT NULL,
	"INTEGRATIONID" CHAR(36) NULL,
	"INTEGRATIONLABEL" NVARCHAR2(100) NULL,
	"DATAKEY" NVARCHAR2(100) NULL,
	"DATA" NVARCHAR2(450) NULL,
	"DATACODE" NUMBER(10,0) NOT NULL,
	"TEXT" NCLOB NULL,
	"TIMESTAMP" NUMBER(19,0) NOT NULL,
	"CUSTOMSORTING" NUMBER(10,0) NOT NULL,
	"DATETIME" TIMESTAMP(3) NOT NULL,
 CONSTRAINT "PK_PAGEEVENTS" PRIMARY KEY  
(
	"PAGEEVENTID"
)
) 
/
CREATE  INDEX "IX_BYDATEPAGEEVENTS" ON "PAGEEVENTS" 
(
	"DATETIME"
)
/
CREATE  INDEX "IX_BYDEFINITIONPAGEEVENTS" ON "PAGEEVENTS" 
(
	"PAGEEVENTDEFINITIONID",
	"VISITID",
	"DATAKEY",
	"ITEMID"
)
/
CREATE  INDEX "IX_BYVISITORPAGEEVENTS" ON "PAGEEVENTS" 
(
	"VISITORID",
	"VISITID"
)
/
CREATE MATERIALIZED VIEW "TRAFFICBYDAY"  AS 
SELECT
  TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD') "DATE", 
  TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMM') || '01' "MONTH",
  "VISITS"."TRAFFICTYPE", 
  "VISITS"."CAMPAIGNID", 
  "PAGES"."ITEMID", 
  LOWER(SUBSTR(SUBSTR(TO_CHAR( "ITEMURLS"."URL"),1,800), 1, INSTR( "ITEMURLS"."URL" || '?','?') - 1)) "URL", 
  "VISITS"."KEYWORDSID", 
  LOWER(SUBSTR(TO_CHAR( "KEYWORDS"."TEXT"),1,400)) "KEYWORDS", 
  "VISITS"."REFERRINGSITEID", 
  LOWER("REFERRINGSITES"."HOST") "REFERRINGSITE",
  (CASE WHEN "VISITS"."VISITORVISITINDEX" = 1 THEN 1 ELSE 0 END) "FIRSTVISIT",
  COUNT(*) AS "VISITS", SUM("VISITS"."VALUE") AS "VALUE"
FROM 
  "VISITS"
  INNER JOIN "KEYWORDS" ON "VISITS"."KEYWORDSID" = "KEYWORDS"."KEYWORDSID" 
  INNER JOIN "PAGES" ON "VISITS"."VISITID" = "PAGES"."VISITID" AND "PAGES"."VISITPAGEINDEX" = 1 AND "PAGES"."ITEMID" <> '00000000-0000-0000-0000-000000000000' 
  INNER JOIN "ITEMURLS" ON "PAGES"."ITEMID" = "ITEMURLS"."ITEMID" 
  INNER JOIN "REFERRINGSITES" ON "VISITS"."REFERRINGSITEID" = "REFERRINGSITES"."REFERRINGSITEID"
GROUP BY 
  TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD'), TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMM') || '01',
  "VISITS"."TRAFFICTYPE", "VISITS"."CAMPAIGNID", "PAGES"."ITEMID", LOWER(SUBSTR(SUBSTR(TO_CHAR( "ITEMURLS"."URL"),1,800), 1, INSTR( "ITEMURLS"."URL" || '?','?') - 1)), 
  "VISITS"."KEYWORDSID", LOWER(SUBSTR(TO_CHAR( "KEYWORDS"."TEXT"),1,400)), 
  "VISITS"."REFERRINGSITEID", LOWER("REFERRINGSITES"."HOST"), (CASE WHEN "VISITS"."VISITORVISITINDEX" = 1 THEN 1 ELSE 0 END)
/
CREATE UNIQUE  INDEX "PKEYTRAFFICBYDAY" ON "TRAFFICBYDAY" 
(
	"DATE",
	"TRAFFICTYPE",
	"KEYWORDSID",
	"REFERRINGSITEID",
	"CAMPAIGNID",
	"ITEMID",
	"FIRSTVISIT"
)
/
CREATE  INDEX "IX_BYCAMPAIGNTRAFFICBYDAY" ON "TRAFFICBYDAY" 
(
	"CAMPAIGNID",
	"MONTH",
	"DATE"
)
/
CREATE  INDEX "IX_BYTYPETRAFFICBYDAY" ON "TRAFFICBYDAY" 
(
	"TRAFFICTYPE",
	"MONTH",
	"DATE"
)
/
CREATE MATERIALIZED VIEW "VISITEVENTS"
AS
SELECT
  TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD') AS "DATE", TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMM') || '01' AS "MONTH",
  "VISITS"."TRAFFICTYPE", "VISITS"."CAMPAIGNID", "VISITS"."VALUE",
  "PAGEEVENTS"."VISITID", "PAGEEVENTS"."PAGEEVENTDEFINITIONID", "PAGEEVENTDEFINITIONS"."NAME" "PAGEEVENTNAME", 
  "PAGEEVENTDEFINITIONS"."ISGOAL", "PAGES"."ITEMID", "PAGEEVENTS"."ITEMID" "EVENTITEMID", LOWER("PAGEEVENTS"."DATAKEY") "DATAKEY",
  COUNT(*) "NUMBEROFEVENTS"
FROM "PAGEEVENTS", "VISITS", "PAGEEVENTDEFINITIONS", "PAGES"
WHERE 
  "VISITS"."VISITID" = "PAGEEVENTS"."VISITID" AND 
  "PAGEEVENTS"."PAGEEVENTDEFINITIONID" = "PAGEEVENTDEFINITIONS"."PAGEEVENTDEFINITIONID" AND
  "PAGEEVENTS"."PAGEID" = "PAGES"."PAGEID" AND
  ("PAGEEVENTS"."DATAKEY" > ' ' OR "PAGEEVENTDEFINITIONS"."ISGOAL" = 1)
GROUP BY 
  TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMMDD'), TO_CHAR( "VISITS"."STARTDATETIME", 'YYYYMM') || '01',
  "VISITS"."TRAFFICTYPE", "VISITS"."CAMPAIGNID", "VISITS"."VALUE", 
  "PAGEEVENTS"."VISITID", "PAGEEVENTS"."PAGEEVENTDEFINITIONID", "PAGEEVENTDEFINITIONS"."NAME", "PAGEEVENTDEFINITIONS"."ISGOAL",
  LOWER("PAGEEVENTS"."DATAKEY"), "PAGES"."ITEMID", "PAGEEVENTS"."ITEMID"
/
CREATE UNIQUE  INDEX "PKEYVISITEVENTS" ON "VISITEVENTS" 
(
	"ISGOAL",
	"VISITID",
	"PAGEEVENTDEFINITIONID",
	"DATAKEY",
	"ITEMID",
	"EVENTITEMID"
)
/
CREATE  INDEX "IX_EVENTSBYCAMPAIGNVISITEVENTS" ON "VISITEVENTS" 
(
	"ISGOAL",
	"PAGEEVENTDEFINITIONID",
	"CAMPAIGNID",
	"MONTH",
	"DATE",
	"DATAKEY"
)
/
CREATE  INDEX "IX_GOALSBYCAMPAIGNVISITEVENTS" ON "VISITEVENTS" 
(
	"ISGOAL",
	"CAMPAIGNID",
	"PAGEEVENTDEFINITIONID",
	"MONTH",
	"DATE",
	"DATAKEY"
)
/
CREATE  INDEX "IX_GOALSBYITEMIDVISITEVENTS" ON "VISITEVENTS" 
(
	"ITEMID",
	"ISGOAL",
	"PAGEEVENTDEFINITIONID",
	"DATE",
	"DATAKEY"
)
/
CREATE VIEW "TRAFFICOVERVIEW" AS
SELECT "DATE"
      ,"MONTH"
      ,"TRAFFICTYPE"
      ,"CAMPAIGNID"
      ,"ITEMID"
      ,"URL"
      ,"KEYWORDSID"
      ,"KEYWORDS"
      ,"REFERRINGSITEID"
      ,"REFERRINGSITE"
      ,"FIRSTVISIT"
      ,"VISITS"
      ,"VALUE"
  FROM "TRAFFICBYDAY" 
/
CREATE VIEW "VISITEVENTSBYPAGE"
AS
SELECT 
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "ITEMID",
  "VALUE",
  "ISGOAL",
  SUM("NUMBEROFEVENTS") "NUMBEROFEVENTS"
FROM "VISITEVENTS" 
GROUP BY
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "ITEMID",
  "VALUE",
  "ISGOAL"
/
CREATE VIEW "VISITEVENTSBYDEFINITION"
AS
SELECT 
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "VALUE",
  "ISGOAL",
  SUM("NUMBEROFEVENTS") "NUMBEROFEVENTS"
FROM "VISITEVENTS" 
GROUP BY
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "VALUE",
  "ISGOAL"
/
CREATE VIEW "VISITEVENTSBYDATAKEY"
AS
SELECT 
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "DATAKEY",
  "VALUE",
  "ISGOAL",
  SUM("NUMBEROFEVENTS") "NUMBEROFEVENTS"
FROM "VISITEVENTS" 
GROUP BY
  "DATE", 
  "MONTH",
  "TRAFFICTYPE",
  "CAMPAIGNID",
  "VISITID",
  "PAGEEVENTDEFINITIONID",
  "PAGEEVENTNAME",
  "DATAKEY",
  "VALUE",
  "ISGOAL"
/
CREATE VIEW "CAMPAIGNSOVERVIEW"
AS
SELECT 
  "TRAFFICOVERVIEW"."DATE", "TRAFFICOVERVIEW"."MONTH",
  "TRAFFICOVERVIEW"."ITEMID", "TRAFFICOVERVIEW"."URL", 
  "TRAFFICOVERVIEW"."KEYWORDSID", "TRAFFICOVERVIEW"."KEYWORDS", "TRAFFICOVERVIEW"."REFERRINGSITEID", "TRAFFICOVERVIEW"."REFERRINGSITE", "TRAFFICOVERVIEW"."FIRSTVISIT",
  "CAMPAIGNS"."CAMPAIGNNAME", "CAMPAIGNS"."CATEGORY1ID", "CAMPAIGNS"."CATEGORY2ID", "CAMPAIGNS"."CATEGORY3ID", "CAMPAIGNS"."CAMPAIGNID",
  "TRAFFICOVERVIEW"."VISITS","TRAFFICOVERVIEW"."VALUE"
FROM "TRAFFICOVERVIEW", "CAMPAIGNS" 
WHERE "TRAFFICOVERVIEW"."CAMPAIGNID" = "CAMPAIGNS"."CAMPAIGNID"
/
ALTER TABLE "REFERRINGSITES"   ADD  CONSTRAINT "FK_REFERRINGSITES_TRAFFICTYPES" FOREIGN KEY("TRAFFICTYPE")
REFERENCES "TRAFFICTYPES" ("TRAFFICTYPE")
/
ALTER TABLE "GEOIPS"   ADD  CONSTRAINT "FK_GEOIPS_VC" FOREIGN KEY("VISITORCLASSIFICATION")
REFERENCES "VISITORCLASSIFICATIONS" ("VISITORCLASSIFICATION")
/
ALTER TABLE "LOCATIONS"   ADD  CONSTRAINT "FK_LOCATIONS_VC" FOREIGN KEY("VISITORCLASSIFICATION")
REFERENCES "VISITORCLASSIFICATIONS" ("VISITORCLASSIFICATION")
/
ALTER TABLE "AUTOMATIONS"   ADD  CONSTRAINT "FK_AUTOMATION_CAMPAIGN" FOREIGN KEY("CAMPAIGNID")
REFERENCES "CAMPAIGNS" ("CAMPAIGNID")
/
ALTER TABLE "VISITORS"   ADD  CONSTRAINT "FK_VISITORS_VC" FOREIGN KEY("VISITORCLASSIFICATION")
REFERENCES "VISITORCLASSIFICATIONS" ("VISITORCLASSIFICATION")
/
ALTER TABLE "VISITORS"   ADD  CONSTRAINT "FK_VISITORS_VC1" FOREIGN KEY("OVERRIDEVISITORCLASSIFICATION")
REFERENCES "VISITORCLASSIFICATIONS" ("VISITORCLASSIFICATION")
/
ALTER TABLE "USERAGENTS"   ADD  CONSTRAINT "FK_USERAGENTS_VC" FOREIGN KEY("VISITORCLASSIFICATION")
REFERENCES "VISITORCLASSIFICATIONS" ("VISITORCLASSIFICATION")
/
ALTER TABLE "NOTIFICATIONSUBSCRIPTIONS"   ADD  CONSTRAINT "FK_NS_LOCATIONS" FOREIGN KEY("LOCATIONID")
REFERENCES "LOCATIONS" ("LOCATIONID")
/
ALTER TABLE "AUTOMATIONSTATES"   ADD  CONSTRAINT "FK_AUTOMATIONSTATES_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "AUTOMATIONSTATES"   ADD  CONSTRAINT "FK_MAS_MARKETINGAUTOMATIONS" FOREIGN KEY("AUTOMATIONID")
REFERENCES "AUTOMATIONS" ("AUTOMATIONID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_BROWSERS" FOREIGN KEY("BROWSERID")
REFERENCES "BROWSERS" ("BROWSERID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_CAMPAIGNS" FOREIGN KEY("CAMPAIGNID")
REFERENCES "CAMPAIGNS" ("CAMPAIGNID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_GEOIPS" FOREIGN KEY("IP")
REFERENCES "GEOIPS" ("IP")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_KEYWORDS" FOREIGN KEY("KEYWORDSID")
REFERENCES "KEYWORDS" ("KEYWORDSID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_LOCATIONS" FOREIGN KEY("LOCATIONID")
REFERENCES "LOCATIONS" ("LOCATIONID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_OS" FOREIGN KEY("OSID")
REFERENCES "OS" ("OSID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_REFERRINGSITES" FOREIGN KEY("REFERRINGSITEID")
REFERENCES "REFERRINGSITES" ("REFERRINGSITEID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_SCREENS" FOREIGN KEY("SCREENID")
REFERENCES "SCREENS" ("SCREENID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_TRAFFICTYPES" FOREIGN KEY("TRAFFICTYPE")
REFERENCES "TRAFFICTYPES" ("TRAFFICTYPE")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_USERAGENTS" FOREIGN KEY("USERAGENTID")
REFERENCES "USERAGENTS" ("USERAGENTID")
/
ALTER TABLE "VISITS"   ADD  CONSTRAINT "FK_VISITS_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "VISITORTAGS"   ADD  CONSTRAINT "FK_VISITORTAGS_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "PROFILES"   ADD  CONSTRAINT "FK_PROFILE_VISITS" FOREIGN KEY("VISITID")
REFERENCES "VISITS" ("VISITID")
/
ALTER TABLE "PROFILES"   ADD  CONSTRAINT "FK_PROFILES_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "PAGES"   ADD  CONSTRAINT "FK_PAGES_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "PAGES"   ADD  CONSTRAINT "FK_PAGES_VISITS" FOREIGN KEY("VISITID")
REFERENCES "VISITS" ("VISITID")
/
ALTER TABLE "PAGEEVENTS"   ADD  CONSTRAINT "FK_PAGEEVENTS_PED" FOREIGN KEY("PAGEEVENTDEFINITIONID")
REFERENCES "PAGEEVENTDEFINITIONS" ("PAGEEVENTDEFINITIONID")
/
ALTER TABLE "PAGEEVENTS"   ADD  CONSTRAINT "FK_PAGEEVENTS_PAGES" FOREIGN KEY("PAGEID")
REFERENCES "PAGES" ("PAGEID")
/
ALTER TABLE "PAGEEVENTS"   ADD  CONSTRAINT "FK_PAGEEVENTS_VISITORS" FOREIGN KEY("VISITORID")
REFERENCES "VISITORS" ("VISITORID")
/
ALTER TABLE "PAGEEVENTS"   ADD  CONSTRAINT "FK_PAGEEVENTS_VISITS" FOREIGN KEY("VISITID")
REFERENCES "VISITS" ("VISITID")
/
CREATE OR REPLACE FUNCTION "GETVISITORCLASSIFICATION"
(
           overridden INTEGER,
           p0 INTEGER,
           p1 INTEGER,
           p2 INTEGER,
           p3 INTEGER,
           p4 INTEGER
)
RETURN INTEGER
IS
  res INTEGER;
BEGIN
  IF overridden = 0 OR overridden = 925 THEN /* Autodetects bot - special logic */
      res := P0;
    
      IF RES IS NULL OR P1 > RES THEN RES := P1; END IF;
      IF res IS NULL OR P2 > res THEN res := P2; END IF;
      IF RES IS NULL OR P3 > RES THEN RES := P3; END IF;
      IF RES IS NULL OR P4 > RES THEN RES := P4; END IF;
  
      IF OVERRIDDEN = 925 AND res < 900 THEN /* If Autodetected as a robot (925), and previous classification is a human, still return 925 */
        res := OVERRIDDEN;
      END IF;
  ELSE
      res := OVERRIDDEN;
  END IF;        

  RETURN RES;
END;
/
CREATE TRIGGER "UPDATEITEMURLS" 
AFTER INSERT
ON "PAGES" 
FOR EACH ROW
BEGIN
  INSERT INTO "ITEMURLS" ("ITEMID", "URL") 
  SELECT DISTINCT :NEW."ITEMID", :NEW."URL" FROM DUAL
  WHERE NOT EXISTS (SELECT * FROM "ITEMURLS" WHERE "ITEMID" = :NEW."ITEMID");
END;
/
CREATE OR REPLACE
FUNCTION "FORMAT_GUID"
  (guid IN RAW) RETURN CHAR
AS
  v VARCHAR2(36);
BEGIN
  v := TO_CHAR(LOWER(guid));
  v := SUBSTR(v, 1, 8) || '-' || SUBSTR(v, 9, 4) || '-' || SUBSTR(v, 13, 4) || '-' || SUBSTR(v, 17, 4) || '-' || SUBSTR(v, 21);
  return v;
END;
/
CREATE OR REPLACE
PROCEDURE "SP_SC_REFRESH_VIEWS"
AS
BEGIN
    DBMS_MVIEW.REFRESH('"TRAFFICBYDAY"','C');
    DBMS_MVIEW.REFRESH('"VALUEBYSOURCE"','C');
    DBMS_MVIEW.REFRESH('"VISITEVENTS"','C');
    DBMS_MVIEW.REFRESH('"VISITORSBYLOCATION"','C');
END;
/
CREATE OR REPLACE
PROCEDURE "SP_SC_DISABLE_CONSTRAINTS"
AS
  CURSOR x IS select table_name, constraint_name from user_constraints where constraint_type = 'R';
BEGIN
  FOR r IN x
  LOOP
    EXECUTE IMMEDIATE 'ALTER TABLE "' || R.TABLE_NAME || '" DISABLE CONSTRAINT "' || R.CONSTRAINT_NAME || '"';
  END LOOP;
END;
/
CREATE OR REPLACE
PROCEDURE "SP_SC_ENABLE_CONSTRAINTS"
AS
  CURSOR x IS select table_name, constraint_name from user_constraints where constraint_type = 'R';
BEGIN
  FOR r IN x
  LOOP
    EXECUTE IMMEDIATE 'ALTER TABLE "' || R.TABLE_NAME || '" ENABLE CONSTRAINT "' || R.CONSTRAINT_NAME || '"';
  END LOOP;
END;
/
BEGIN
  dbms_scheduler.create_program('P_SC_REFRESH_VIEWS', 'STORED_PROCEDURE', '"SP_SC_REFRESH_VIEWS"');
  dbms_scheduler.enable('P_SC_REFRESH_VIEWS');
  dbms_scheduler.create_schedule('NIGHTLY_23_30', SYSDATE(), 'FREQ=DAILY;INTERVAL=1;BYHOUR=23;BYMINUTE=30;BYSECOND=0');
  dbms_scheduler.create_job('JOB_SC_REFRESH_VIEWS', program_name => 'P_SC_REFRESH_VIEWS', schedule_name => 'NIGHTLY_23_30');
  dbms_scheduler.enable('JOB_SC_REFRESH_VIEWS');
END;
/
BEGIN
  "SP_SC_DISABLE_CONSTRAINTS";
END;
/
exit
